---------------------
PatchSet 3676 
Date: 2006/09/03 16:51:20
Author: serassio
Branch: nt
Tag: (none) 
Log:
Drop IPC refactored support (moved to ipc branch) an forward port latest 2.6 changes

Members: 
	configure.in:1.26.2.97->1.26.2.98 
	src/Makefile.am:1.26.2.87->1.26.2.88 
	src/defines.h:1.6.2.9->1.6.2.10 
	src/dns.cc:1.5.2.8->1.5.2.9 
	src/external_acl.cc:1.14.2.37->1.14.2.38 
	src/helper.cc:1.10.2.19->1.10.2.20 
	src/icmp.cc:1.7.2.8->1.7.2.9 
	src/ipc.cc:1.8.2.21->1.8.2.22 
	src/ipc.h:1.1.18.1->1.1.18.2(DEAD) 
	src/ipc_win32.cc:1.1->1.1.2.1 
	src/protos.h:1.19.2.58->1.19.2.59 
	src/redirect.cc:1.5.2.17->1.5.2.18 
	src/unlinkd.cc:1.7.2.10->1.7.2.11 
	src/DiskIO/DiskDaemon/DiskdIOStrategy.cc:1.1.2.3->1.1.2.4 

Index: squid3/configure.in
===================================================================
RCS file: /cvsroot/squid-sf//squid3/configure.in,v
retrieving revision 1.26.2.97
retrieving revision 1.26.2.98
diff -u -r1.26.2.97 -r1.26.2.98
--- squid3/configure.in	3 Sep 2006 08:44:13 -0000	1.26.2.97
+++ squid3/configure.in	3 Sep 2006 16:51:20 -0000	1.26.2.98
@@ -1,7 +1,7 @@
 
 dnl  Configuration input file for Squid
 dnl
-dnl  $Id: configure.in,v 1.26.2.97 2006/09/03 08:44:13 serassio Exp $
+dnl  $Id: configure.in,v 1.26.2.98 2006/09/03 16:51:20 serassio Exp $
 dnl
 dnl
 dnl
@@ -11,7 +11,7 @@
 AC_CONFIG_AUX_DIR(cfgaux)
 AC_CONFIG_SRCDIR([src/main.cc])
 AM_INIT_AUTOMAKE([tar-ustar])
-AC_REVISION($Revision: 1.26.2.97 $)dnl
+AC_REVISION($Revision: 1.26.2.98 $)dnl
 AC_PREFIX_DEFAULT(/usr/local/squid)
 AM_MAINTAINER_MODE
 
@@ -75,8 +75,12 @@
 		LIBS="$LIBS -lpsapi"
 	fi
 	MINGW_LIBS="-lmingwex"
+	AM_CONDITIONAL(USE_IPC_WIN32, true)
 	AC_SUBST(MINGW_LIBS)
 	;;
+*)
+	AM_CONDITIONAL(USE_IPC_WIN32, false)
+	;;
 esac
 
 if test -z "$CACHE_HTTP_PORT"; then
Index: squid3/src/Makefile.am
===================================================================
RCS file: /cvsroot/squid-sf//squid3/src/Makefile.am,v
retrieving revision 1.26.2.87
retrieving revision 1.26.2.88
diff -u -r1.26.2.87 -r1.26.2.88
--- squid3/src/Makefile.am	2 Sep 2006 20:07:09 -0000	1.26.2.87
+++ squid3/src/Makefile.am	3 Sep 2006 16:51:22 -0000	1.26.2.88
@@ -1,7 +1,7 @@
 #
 #  Makefile for the Squid Object Cache server
 #
-#  $Id: Makefile.am,v 1.26.2.87 2006/09/02 20:07:09 serassio Exp $
+#  $Id: Makefile.am,v 1.26.2.88 2006/09/03 16:51:22 serassio Exp $
 #
 #  Uncomment and customize the following to suit your needs:
 #
@@ -147,6 +147,12 @@
 WIN32_SOURCE = 
 endif
 
+if USE_IPC_WIN32
+IPC_SOURCE = ipc_win32.cc
+else
+IPC_SOURCE = ipc.cc
+endif
+
 IDENT_ALL_SOURCE = ACLIdent.cc ACLIdent.h ident.cc
 if ENABLE_IDENT
 IDENT_SOURCE = $(IDENT_ALL_SOURCE)
@@ -254,6 +260,8 @@
 	dnsserver.cc \
 	dns_internal.cc \
 	htcp.cc \
+	ipc.cc \
+	ipc_win32.cc \
 	htcp.h \
 	$(IDENT_ALL_SOURCE) \
 	$(ESI_ALL_SOURCE) \
@@ -485,8 +493,7 @@
 	$(IDENT_SOURCE) \
 	int.cc \
 	internal.cc \
-	ipc.cc \
-	ipc.h \
+	$(IPC_SOURCE) \
 	ipcache.cc \
 	$(LEAKFINDERSOURCE) \
 	list.cc \
@@ -782,7 +789,7 @@
 	icp_v3.cc \
 	$(IDENT_SOURCE) \
 	internal.cc \
-	ipc.cc \
+	$(IPC_SOURCE) \
 	ipcache.cc \
 	$(LEAKFINDERSOURCE) \
         list.cc \
@@ -1289,7 +1296,7 @@
 	icp_v2.cc \
 	icp_v3.cc \
 	$(IDENT_SOURCE) \
-	ipc.cc \
+	$(IPC_SOURCE) \
 	ipcache.cc \
 	int.cc \
 	internal.cc \
@@ -1440,7 +1447,7 @@
 	icp_v2.cc \
 	icp_v3.cc \
 	$(IDENT_SOURCE) \
-	ipc.cc \
+	$(IPC_SOURCE) \
 	ipcache.cc \
 	int.cc \
 	internal.cc \
@@ -1590,7 +1597,7 @@
 	icp_v2.cc \
 	icp_v3.cc \
 	$(IDENT_SOURCE) \
-	ipc.cc \
+	$(IPC_SOURCE) \
 	ipcache.cc \
 	int.cc \
 	internal.cc \
@@ -1770,7 +1777,7 @@
 	$(IDENT_SOURCE) \
 	int.cc \
 	internal.cc \
-	ipc.cc \
+	$(IPC_SOURCE) \
 	ipcache.cc \
 	list.cc \
 	logfile.cc \
@@ -1918,7 +1925,7 @@
 	icp_v2.cc \
 	icp_v3.cc \
 	$(IDENT_SOURCE) \
-	ipc.cc \
+	$(IPC_SOURCE) \
 	ipcache.cc \
 	int.cc \
 	internal.cc \
@@ -2251,7 +2258,7 @@
 	icp_v2.cc \
 	icp_v3.cc \
 	$(IDENT_SOURCE) \
-	ipc.cc \
+	$(IPC_SOURCE) \
 	ipcache.cc \
 	int.cc \
 	internal.cc \
Index: squid3/src/defines.h
===================================================================
RCS file: /cvsroot/squid-sf//squid3/src/defines.h,v
retrieving revision 1.6.2.9
retrieving revision 1.6.2.10
diff -u -r1.6.2.9 -r1.6.2.10
--- squid3/src/defines.h	22 Aug 2006 10:26:04 -0000	1.6.2.9
+++ squid3/src/defines.h	3 Sep 2006 16:51:23 -0000	1.6.2.10
@@ -1,6 +1,6 @@
 
 /*
- * $Id: defines.h,v 1.6.2.9 2006/08/22 10:26:04 serassio Exp $
+ * $Id: defines.h,v 1.6.2.10 2006/09/03 16:51:23 serassio Exp $
  *
  *
  * SQUID Web Proxy Cache          http://www.squid-cache.org/
@@ -180,6 +180,21 @@
 #define STORE_META_DIRTY  0x04
 #define STORE_META_BAD    0x05
 
+#define IPC_NONE 0
+#define IPC_TCP_SOCKET 1
+#define IPC_UDP_SOCKET 2
+#define IPC_FIFO 3
+#define IPC_UNIX_STREAM 4
+#define IPC_UNIX_DGRAM 5
+
+#if HAVE_SOCKETPAIR && defined (AF_UNIX)
+#define IPC_STREAM IPC_UNIX_STREAM
+#define IPC_DGRAM IPC_UNIX_DGRAM
+#else
+#define IPC_STREAM IPC_TCP_SOCKET
+#define IPC_DGRAM IPC_UDP_SOCKET
+#endif
+
 #define STORE_META_KEY STORE_META_KEY_MD5
 
 #define STORE_META_TLD_START sizeof(int)+sizeof(char)
Index: squid3/src/dns.cc
===================================================================
RCS file: /cvsroot/squid-sf//squid3/src/dns.cc,v
retrieving revision 1.5.2.8
retrieving revision 1.5.2.9
diff -u -r1.5.2.8 -r1.5.2.9
--- squid3/src/dns.cc	31 May 2006 21:17:02 -0000	1.5.2.8
+++ squid3/src/dns.cc	3 Sep 2006 16:51:23 -0000	1.5.2.9
@@ -1,6 +1,6 @@
 
 /*
- * $Id: dns.cc,v 1.5.2.8 2006/05/31 21:17:02 serassio Exp $
+ * $Id: dns.cc,v 1.5.2.9 2006/09/03 16:51:23 serassio Exp $
  *
  * DEBUG: section 34    Dnsserver interface
  * AUTHOR: Harvest Derived
@@ -45,9 +45,6 @@
  */
 #if USE_DNSSERVERS
 
-/* For the IPC type defines */
-#include "ipc.h"
-
 static helper *dnsservers = NULL;
 
 static void
Index: squid3/src/external_acl.cc
===================================================================
RCS file: /cvsroot/squid-sf//squid3/src/external_acl.cc,v
retrieving revision 1.14.2.37
retrieving revision 1.14.2.38
diff -u -r1.14.2.37 -r1.14.2.38
--- squid3/src/external_acl.cc	22 Aug 2006 10:26:04 -0000	1.14.2.37
+++ squid3/src/external_acl.cc	3 Sep 2006 16:51:23 -0000	1.14.2.38
@@ -1,6 +1,6 @@
 
 /*
- * $Id: external_acl.cc,v 1.14.2.37 2006/08/22 10:26:04 serassio Exp $
+ * $Id: external_acl.cc,v 1.14.2.38 2006/09/03 16:51:23 serassio Exp $
  *
  * DEBUG: section 82    External ACL
  * AUTHOR: Henrik Nordstrom, MARA Systems AB
@@ -47,7 +47,6 @@
 #include "AuthUserRequest.h"
 #include "SquidTime.h"
 #include "Store.h"
-#include "ipc.h"
 #include "fde.h"
 #include "ACLChecklist.h"
 #include "ACL.h"
Index: squid3/src/helper.cc
===================================================================
RCS file: /cvsroot/squid-sf//squid3/src/helper.cc,v
retrieving revision 1.10.2.19
retrieving revision 1.10.2.20
diff -u -r1.10.2.19 -r1.10.2.20
--- squid3/src/helper.cc	22 Aug 2006 10:26:05 -0000	1.10.2.19
+++ squid3/src/helper.cc	3 Sep 2006 16:51:26 -0000	1.10.2.20
@@ -1,6 +1,6 @@
 
 /*
- * $Id: helper.cc,v 1.10.2.19 2006/08/22 10:26:05 serassio Exp $
+ * $Id: helper.cc,v 1.10.2.20 2006/09/03 16:51:26 serassio Exp $
  *
  * DEBUG: section 84    Helper process maintenance
  * AUTHOR: Harvest Derived?
@@ -39,7 +39,6 @@
 #include "Store.h"
 #include "comm.h"
 #include "MemBuf.h"
-#include "ipc.h"
 #include "wordlist.h"
 
 #define HELPER_MAX_ARGS 64
@@ -81,6 +80,10 @@
     helper_server *srv;
     int nargs = 0;
     int k;
+    pid_t pid;
+    int rfd;
+    int wfd;
+    void * hIpc; 
     wordlist *w;
 
     if (hlp->cmdline == NULL)
@@ -111,12 +114,16 @@
 
     for (k = 0; k < hlp->n_to_start; k++) {
         getCurrentTime();
-        IPCResult ipcRV = ipcCreate(hlp->ipc_type,
-                                    progname,
-                                    args,
-                                    shortname);
+        rfd = wfd = -1;
+        pid = ipcCreate(hlp->ipc_type,
+                      progname,
+                      args,
+                      shortname,
+                      &rfd,
+                      &wfd,
+			&hIpc);
 
-        if (!ipcRV.success) {
+        if (pid < 0) {
             debug(84, 1) ("WARNING: Cannot run '%s' process.\n", progname);
             continue;
         }
@@ -125,15 +132,11 @@
         hlp->n_active++;
 	CBDATA_INIT_TYPE(helper_server);
         srv = cbdataAlloc(helper_server);
-#ifdef _SQUID_MSWIN_
-
-        srv->hIpc = ipcRV.hIpc;
-#endif
-
-        srv->pid = ipcRV.pid;
+        srv->hIpc = hIpc;
+        srv->pid = pid;
         srv->index = k;
-        srv->rfd = ipcRV.rfd;
-        srv->wfd = ipcRV.wfd;
+        srv->rfd = rfd;
+        srv->wfd = wfd;
         srv->rbuf = (char *)memAllocBuf(8192, &srv->rbuf_sz);
         srv->wqueue = new MemBuf;
         srv->roffset = 0;
@@ -141,22 +144,22 @@
         srv->parent = cbdataReference(hlp);
         dlinkAddTail(srv, &srv->link, &hlp->servers);
 
-        if (srv->rfd == srv->wfd) {
+        if (rfd == wfd) {
             snprintf(fd_note_buf, FD_DESC_SZ, "%s #%d", shortname, k + 1);
-            fd_note(srv->rfd, fd_note_buf);
+            fd_note(rfd, fd_note_buf);
         } else {
             snprintf(fd_note_buf, FD_DESC_SZ, "reading %s #%d", shortname, k + 1);
-            fd_note(srv->rfd, fd_note_buf);
+            fd_note(rfd, fd_note_buf);
             snprintf(fd_note_buf, FD_DESC_SZ, "writing %s #%d", shortname, k + 1);
-            fd_note(srv->wfd, fd_note_buf);
+            fd_note(wfd, fd_note_buf);
         }
 
-        commSetNonBlocking(srv->rfd);
+        commSetNonBlocking(rfd);
 
-        if (srv->wfd != srv->rfd)
-            commSetNonBlocking(srv->wfd);
+        if (wfd != rfd)
+            commSetNonBlocking(wfd);
 
-        comm_add_close_handler(srv->rfd, helperServerFree, srv);
+        comm_add_close_handler(rfd, helperServerFree, srv);
 
         comm_read(srv->rfd, srv->rbuf, srv->rbuf_sz - 1, helperHandleRead, srv);
     }
@@ -179,6 +182,10 @@
     helper_stateful_server *srv;
     int nargs = 0;
     int k;
+    pid_t pid;
+    int rfd;
+    int wfd;
+    void * hIpc;
     wordlist *w;
 
     if (hlp->cmdline == NULL)
@@ -209,12 +216,16 @@
 
     for (k = 0; k < hlp->n_to_start; k++) {
         getCurrentTime();
-        IPCResult ipcRV = ipcCreate(hlp->ipc_type,
-                                    progname,
-                                    args,
-                                    shortname);
+        rfd = wfd = -1;
+        pid = ipcCreate(hlp->ipc_type,
+                      progname,
+                      args,
+                      shortname,
+                      &rfd,
+                      &wfd,
+			&hIpc);
 
-        if (!ipcRV.success) {
+        if (pid < 0) {
             debug(84, 1) ("WARNING: Cannot run '%s' process.\n", progname);
             continue;
         }
@@ -223,12 +234,8 @@
         hlp->n_active++;
 	CBDATA_INIT_TYPE(helper_stateful_server);
         srv = cbdataAlloc(helper_stateful_server);
-#ifdef _SQUID_MSWIN_
-
-        srv->hIpc = ipcRV.hIpc;
-#endif
-
-        srv->pid = ipcRV.pid;
+        srv->hIpc = hIpc;
+        srv->pid = pid;
         srv->flags.reserved = S_HELPER_FREE;
         srv->deferred_requests = 0;
         srv->stats.deferbyfunc = 0;
@@ -236,9 +243,9 @@
         srv->stats.submits = 0;
         srv->stats.releases = 0;
         srv->index = k;
-        srv->rfd = ipcRV.rfd;
-        srv->wfd = ipcRV.wfd;
-        srv->rbuf = (char *)memAllocBuf(8192, &srv->rbuf_sz);
+        srv->rfd = rfd;
+        srv->wfd = wfd;
+         srv->rbuf = (char *)memAllocBuf(8192, &srv->rbuf_sz);
         srv->roffset = 0;
         srv->parent = cbdataReference(hlp);
 
@@ -247,22 +254,22 @@
 
         dlinkAddTail(srv, &srv->link, &hlp->servers);
 
-        if (srv->rfd == srv->wfd) {
+        if (rfd == wfd) {
             snprintf(fd_note_buf, FD_DESC_SZ, "%s #%d", shortname, k + 1);
-            fd_note(srv->rfd, fd_note_buf);
+            fd_note(rfd, fd_note_buf);
         } else {
             snprintf(fd_note_buf, FD_DESC_SZ, "reading %s #%d", shortname, k + 1);
-            fd_note(srv->rfd, fd_note_buf);
+            fd_note(rfd, fd_note_buf);
             snprintf(fd_note_buf, FD_DESC_SZ, "writing %s #%d", shortname, k + 1);
-            fd_note(srv->wfd, fd_note_buf);
+            fd_note(wfd, fd_note_buf);
         }
 
-        commSetNonBlocking(srv->rfd);
+        commSetNonBlocking(rfd);
 
-        if (srv->wfd != srv->rfd)
-            commSetNonBlocking(srv->wfd);
+        if (wfd != rfd)
+            commSetNonBlocking(wfd);
 
-        comm_add_close_handler(srv->rfd, helperStatefulServerFree, srv);
+        comm_add_close_handler(rfd, helperStatefulServerFree, srv);
 
         comm_read(srv->rfd, srv->rbuf, srv->rbuf_sz - 1, helperStatefulHandleRead, srv);
 
Index: squid3/src/icmp.cc
===================================================================
RCS file: /cvsroot/squid-sf//squid3/src/icmp.cc,v
retrieving revision 1.7.2.8
retrieving revision 1.7.2.9
diff -u -r1.7.2.8 -r1.7.2.9
--- squid3/src/icmp.cc	2 Sep 2006 16:02:52 -0000	1.7.2.8
+++ squid3/src/icmp.cc	3 Sep 2006 16:51:26 -0000	1.7.2.9
@@ -1,6 +1,6 @@
 
 /*
- * $Id: icmp.cc,v 1.7.2.8 2006/09/02 16:02:52 serassio Exp $
+ * $Id: icmp.cc,v 1.7.2.9 2006/09/03 16:51:26 serassio Exp $
  *
  * DEBUG: section 37    ICMP Routines
  * AUTHOR: Duane Wessels
@@ -36,7 +36,6 @@
 
 #include "squid.h"
 #include "comm.h"
-#include "ipc.h"
 
 #if USE_ICMP
 
@@ -53,9 +52,7 @@
 static void icmpHandleSourcePing(const struct sockaddr_in *from, const char *buf);
 #endif
 
-#ifdef _SQUID_MSWIN_
-static HANDLE hIpc;
-#endif
+static void * hIpc;
 static pid_t pid;
 
 static void
@@ -252,6 +249,8 @@
 {
 #if USE_ICMP
     const char *args[2];
+    int rfd;
+    int wfd;
 
     if (strcmp(Config.Program.pinger, "none") == 0) {
         debug(37, 1) ("Pinger disabled\n");
@@ -260,25 +259,20 @@
 
     args[0] = "(pinger)";
     args[1] = NULL;
-    IPCResult ipcRV = ipcCreate(IPC_DGRAM,
-                                Config.Program.pinger,
-                                args,
-                                "Pinger Socket");
+    pid = ipcCreate(IPC_DGRAM,
+                  Config.Program.pinger,
+                  args,
+                  "Pinger Socket",
+                  &rfd,
+                  &wfd,
+			&hIpc);
 
-    if (!ipcRV.success)
+    if (pid < 0)
         return;
 
-#ifdef _SQUID_MSWIN_
-
-    hIpc = ipcRV.hIpc;
-
-    pid = ipcRV.pid;
-
-#endif
-
-    assert(ipcRV.rfd == ipcRV.wfd);
+    assert(rfd == wfd);
 
-    icmp_sock = ipcRV.rfd;
+    icmp_sock = rfd;
 
     fd_note(icmp_sock, "pinger");
 
Index: squid3/src/ipc.cc
===================================================================
RCS file: /cvsroot/squid-sf//squid3/src/ipc.cc,v
retrieving revision 1.8.2.21
retrieving revision 1.8.2.22
diff -u -r1.8.2.21 -r1.8.2.22
--- squid3/src/ipc.cc	14 May 2006 17:11:06 -0000	1.8.2.21
+++ squid3/src/ipc.cc	3 Sep 2006 16:51:26 -0000	1.8.2.22
@@ -1,6 +1,6 @@
 
 /*
- * $Id: ipc.cc,v 1.8.2.21 2006/05/14 17:11:06 serassio Exp $
+ * $Id: ipc.cc,v 1.8.2.22 2006/09/03 16:51:26 serassio Exp $
  *
  * DEBUG: section 54    Interprocess Communication
  * AUTHOR: Duane Wessels
